import java.util.TreeMap;

/**
 *
 * @author show
 */
public class PointStats {
    protected TreeMap<Integer, Average> [] stats = new TreeMap[11];  // per-point
    protected Window window;
    static final int MAX_COUNT = 100;

    public PointStats(int windowSize) {
        for (int point=4; point<=10; point++) {
            stats[point] = new TreeMap<Integer, Average>();
        }
        window = new Window(windowSize);
    }

    public void addRoll(Roll roll) {
        int total = roll.total();
        switch (total) {
			case 7:
				for (int point=4; point<=10; point++) {
					if (point!=7) addOutcome(point, window.getCount(point), 1.0);
				}
                break;
			case 2: case 3: case 11: case 12:
				break;
			default:
				int point = total;
				addOutcome(point, window.getCount(point), -1.0*Analyzer.pointOdds(point));
            	break;
        }
		window.push(roll);
    }

	protected void addOutcome(int point, int count, double outcome) {
		if (!stats[point].containsKey(count)) {
			stats[point].put(count, new Average());
		}
		stats[point].get(count).addSample(outcome);
	}

    public void printSummary() {
        Average avg;
        for (int point=4; point<=10; point++) {
            if (point != 7) {
                System.out.println(String.format("point %d", point));
				for (int count : stats[point].keySet()) {
                    avg = stats[point].get(count);
                    System.out.println(String.format("%+2d %e", count, avg.getAverage()));
                }
            }
        }

    }

}
